%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%
%
%
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function Root_CESS=Evaluating_CESS(NewIncrement,SMCSampler,PercentageCESS,t)

NewIncrement=abs(NewIncrement);
IncrementalWeights=NewIncrement*SMCSampler.LogLike(1,:,t-1);     
PreviousWeights=log(SMCSampler.NormalizedWeights(1,:,t-1));

TotalWeights=IncrementalWeights+PreviousWeights;
TotalWeights2=log(1/SMCSampler.NbPart)+2*IncrementalWeights+PreviousWeights;
TotalWeightsESS2=2*IncrementalWeights+2*PreviousWeights;
CESS=(sum(exp(TotalWeights),2).^2)./sum(exp(TotalWeights2),2);
ESS=(sum(exp(TotalWeights),2).^2)./sum(exp(TotalWeightsESS2),2);


Root_CESS=CESS-PercentageCESS*SMCSampler.NbPart;